<?php

	class Admin_Match extends AdminPage {
		
		function Admin_Match() {			
			parent::AdminPage();			

			$this->status = '';
			$this->content = '';						
			
			$this->db = new DB;	
			$this->t=new Typer_Smarty(ROOT."layout/admin_match/");			
		}
		
		function getContent() {			
			$mode = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'mode' , 1);
			$step = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'step' , 1);

			$roundId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'round' , false);
			$this->roundId = $roundId;		
			
			switch ($mode) {
				case 1:
				default:					
					break;
				case 2:
					switch ($step) {
						case 1:
						default:
							return $this->getEditFormular();
						case 2:							
							return $this->getEditFormular($this->updateData());
					}
				case 3:
					return $this->deleteUser();
			}
			
			return $this->getFormular();
		}
		
		function getEditFormular($matchId = false) {
			
			$roundId = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'round' , false);

			if (! $roundId) {
				$this->status = textSys('admin:match:BRAK_KOLEJKI');
				return;
			}
			$sql = "SELECT roundclosed FROM styper_round WHERE roundid = '{$roundId}'";
			$res = $this->db->table ($sql);
			if (count ($res) > 0 && $res[0][0]) {
				header('location: index.php?fun=40&round=' . $roundId);
				exit();
			}	
		
			if (! $matchId) {
				$matchId = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'match' , false);
			}			
	
			if ( $matchId) {
				$sql = "SELECT * FROM styper_match WHERE matchid = '{$matchId}'";		
				$match = $this->db->table($sql);
			}
			else {
				$match = null;	
			}
			
			if (count ($match) > 0 || $matchId == -1) {
				$this->t->assign('matchid', $matchId == -1 ? -1 : $match[0]['matchid']);				
				$this->t->assign('roundid', $roundId);
				$this->t->assign('match', $match[0]);
				$this->t->assign('STATUS', $this->status);
				$this->t->assign('teams', $this->_getTeamsList());
				return $this->t->fetch('admin_match_edit.ihtml');	
			}
			else {
				$this->status = textSys('admin:match:NIE_MA_TAKIEJ_KOLEJKI');
				return $this->getFormular();
			}			
			
		}

		function goToList() {
			header('location: index.php?fun=40&round=' . $this->roundId);
			exit();
		}
		
		function updateData() {			
		
			/*
			 *  Wymagane pola
			 */
			$match['matchid'] = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'match' , false);
			$match['roundid'] = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'round' , false);
			$match['matchhost'] = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'host' , false);
			$match['matchguest'] = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'guest' , false);		
			
			$eject = false;
			foreach ($match as $u) {
				if (empty($u)) {
					$eject = true;
				}
			}
			

			/*
			 * Uzupelnienie w przypadku przejscia posiadania wymaganych pol 
			 */		
			 
			$match['matchplayed'] =  Verifier::verifyFromREQUEST( CHECKBOX , 'played' , false);
			$match['matchhostscore'] = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'shost' , 'NULL');
			$match['matchguestscore'] = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'sguest' , 'NULL');
			$match['matchspecial'] = Verifier::verifyFromREQUEST( CHECKBOX , 'special' , false);			
			$match['matchdate'] = 'NULL';
			
			$match['matchplayed'] =  $match['matchplayed'] ? '1' : '0';
			$match['matchspecial'] =  $match['matchspecial'] ? '1' : '0';
		
			if ($match['matchid'] == -1 && !$eject) {

				$sql = "INSERT INTO styper_match ";
				$parts = array();
				$partsVal = array();
				foreach ($match as $key => $val) {
					if ($key == 'matchid' || $val == 'NULL') {
						continue;
					}
					$parts [] = "{$key}";
					$partsVal [] = "'{$val}'"; 
				}
				$sql .= '(' . implode (',', $parts) . ')' . ' VALUES(' .  implode (',' , $partsVal) . ")";				
			
				$this->db->query($sql);
				$this->status = textSys('admin:match:MECZ_ZOSTAL_DODANY');
				
				$sql = "SELECT MAX(matchid) FROM styper_match";
				$res = $this->db->table($sql);
				$match['matchid'] = $res[0][0];
				
				$this->goToList();
			}
			else {		
				if (! $eject) {
					
					$sql = "UPDATE styper_match SET ";
					$parts = array();
					
					foreach ($match as $key => $val) {
						
						// nieoquoteowane bool						
						if (!($val == 'true' || $val == 'false' || $val == 'NULL')) {					
							$val = $this->db->quoteString($val);
						}
						$parts[] = "{$key} = {$val}";
					}
					$sql .= implode (',', $parts);
					$sql .= " WHERE matchid = '{$match['matchid']}'";			

					$this->db->query($sql);
				
					$this->status = textSys('admin:match:ZMIANY_ZOSTALY_ZAPISANE');		

					$this->goToList();
				}
			}		
			
			return $match['matchid'];
		}		
		
		function getFormular() {
			
			$roundId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'round' , false);
			$this->roundId = $roundId;
			if ( !$roundId) {
				header('location: index.php?fun=35');
				exit();
			}			

			$this->t->assign('round', $this->_getRoundData($roundId));					
			$this->t->assign('STATUS', $this->status);
			$this->t->assign('matches', $this->_getMatchesList($roundId));
						
			return $this->t->fetch('admin_match.ihtml');
		}
		
		
		function deleteUser() {
			$matchId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'match' , false);
			$me = Typer_Auth::getLoggedUserData(); 
			
			if ($me && $matchId) {			
				
				$sql = "DELETE FROM styper_type WHERE matchid = '{$matchId}'";
				$this->db->query($sql);	
				$sql = "DELETE FROM styper_match WHERE matchid = '{$matchId}'";		
				$this->db->query ($sql);				
			
				$this->status = textSys('admin:match:KOLEJKA_USUNIETA');
				$this->goToList();
			}
			else {
				$this->status = textSys('admin:match:KOLEJKA_NIE_USUNIETA');
			}	
			return $this->getFormular();		
		}
						
	
		function _getTeamsList() {

			$sql = "SELECT * FROM styper_team WHERE teamactive = 1 ORDER BY teamname";
			$res = $this->db->table($sql);		

			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}
		
			return $res;
		}
		
	
		function _getRoundData($roundId = false) {
			if (! $roundId) {
				return false;
			}
			
			$sql = "SELECT * FROM styper_round WHERE roundid = '{$roundId}'";			
			$res = $this->db->table($sql);
			
			return $res[0];
		}
		
		function _getMatchesList($roundId) {

			if ($roundId) {
			$sql = "SELECT *, h.teamname as hostname, g.teamname as guestname FROM styper_match LEFT JOIN styper_team h ON h.teamid = matchhost LEFT JOIN styper_team g ON g.teamid = matchguest WHERE roundid='{$roundId}' ORDER BY matchid ASC";
			$res = $this->db->table($sql);		

			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}
		
			return $res;
			}
		}		
				
			
	}
	

