<?php

	class Admin_Round extends AdminPage {
		
		function Admin_Round() {			
			parent::AdminPage();			

			$this->status = '';
			$this->content = '';						
			
			$this->q = new Queries;
			
			$this->db = new DB;	
			$this->t=new Typer_Smarty(ROOT."layout/admin_round/");			
		}
		
		function getContent() {			
			$mode = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'mode' , 1);
			$step = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'step' , 1);
			
			switch ($mode) {
				case 1:
				default:					
					break;
				case 2:
					switch ($step) {
						case 1:
						default:
							return $this->getEditFormular();
						case 2:							
							return $this->getEditFormular($this->updateData());
					}
				case 3:
					return $this->deleteUser();
			}
			
			return $this->getFormular();
		}
		
		function goToList() {
			header('location: index.php?fun=35');
			exit();
		}
		
		function getEditFormular($roundId = false) {
			if (! $roundId) {
				$roundId = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'round' , false);
			}			
	
			if ( $roundId) {
				$sql = "SELECT * FROM styper_round WHERE roundid = '{$roundId}' AND rounddeleted = 0";		
				$round = $this->db->table($sql);				
			}
			else {
				$round = null;	
			}
			
			if (count ($round) > 0 || $roundId == -1) {
				$this->t->assign('roundid', $roundId == -1 ? -1 : $round[0]['roundid']);				

				// wyswietlenie daty i danych rundy
				$this->t->assign('round', $round[0]);
				if (count ($round) > 0) {
					
					$date = array();
					$date['Y'] = substr($round[0]['roundborn'], 0, 4);
					$date['m'] = substr($round[0]['roundborn'], 5, 2); 
					$date['d'] = substr($round[0]['roundborn'], 8, 2);
					
					$date['h'] = substr($round[0]['roundborn'], 11, 2);
					$date['min'] = substr($round[0]['roundborn'], 14, 2);

					$this->t->assign('date', $date);
				}								
				$this->t->assign('STATUS', $this->status);
				
				// zebranie danych do selectow z data
				$date = Date::getVars();
				
				$this->t->assign('months', $date['months']);
				$this->t->assign('years', $date['years']);
				
				return $this->t->fetch('admin_round_edit.ihtml');	
			}
			else {
				$this->status = textSys('admin:round:BRAK_KOLEJKI');
				return $this->getFormular();
			}			
			
		}

		function updateData() {
			$round['roundid'] = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'round' , false);
			$round['roundname'] = Verifier::verifyFromREQUEST( NOT_NULL_STRING , 'round_name' , false);
			$round['rounddescription'] = Verifier::verifyFromREQUEST( NOT_NULL_STRING , 'round_description' , false);			
			$round['roundborn'] = Verifier::verifyFromREQUEST( DATE_WITHOUT_TIME , 'date' , false);
			$time = Verifier::verifyFromREQUEST( TIME_HOUR_MINUTE , 'time' , false);			
			$round['roundactive'] = Verifier::verifyFromREQUEST( CHECKBOX , 'round_active' , false);
			$round['roundactive'] = $round['roundactive'] ? 'true' : 'false'; 


			$eject = false;
			foreach ($round as $u) {
				if (empty($u)) {
					$eject = true;
				}
			}					
			if ($eject) {
				$this->status = textSys('admin:round:ZMIANY_NIE_ZOSTALY_ZAPISANE');
				return false;
			}			
			
			// zlozenie czasu
			$round['roundborn'] .= ' ' . $time . ':00';			
		
			if ($round['roundid'] == -1 && !$eject) {
			
				$sql = "SELECT * FROM styper_round WHERE roundname = '{$round['roundname']}' AND rounddeleted = 0";
				$res = $this->db->table($sql);
		
				if (count ($res) > 0) {
					$this->status = textSys('admin:round:TAKA_KOLEJKA_JUZ_ISTNIEJE');
					return -1;
				}

				$this->db->query('START TRANSACTION;');				
				/*
				 * Tylko jedna aktywna kolejka
				 */
				if ($round['roundactive'] == 'true') {
					$sql = "UPDATE styper_round SET roundactive = 0 WHERE roundactive = 1";
					$this->db->query($sql);
				}				
				
				$sql = "INSERT INTO styper_round (roundname, rounddescription, roundborn, roundactive) VALUES ('{$round['roundname']}', '{$round['rounddescription']}', '{$round['roundborn']}', {$round['roundactive']})";
				$this->db->query($sql);
				$this->status = textSys('admin:round:KOLEJKA_DODANA');
				$this->db->query('COMMIT;');
				
				$sql = "SELECT MAX(roundid) FROM styper_round";
				$res = $this->db->table($sql);
				$round['roundid'] = $res[0][0];
				
				$this->goToList();
			}
			else {
				
				/*
				 * Blok na ruszanie zamknietych kolejek
				 */
				$sql = "SELECT roundclosed FROM styper_round WHERE roundid = '{$round['roundid']}'";
				$res = $this->db->table ($sql);
				if (count ($res) > 0 && $res[0][0]) {
					header('location: index.php?fun=35&mode=2&round=' . $round['roundid']);
					exit();
				}
					
				if (! $eject) {
					$round['closed'] = Verifier::verifyFromREQUEST( CHECKBOX , 'close_round' , false);				
					
					if ($round['closed']) {
						$sql = "SELECT count(*)
								 FROM styper_match WHERE
								 roundid = '{$round['roundid']}'
							     AND matchplayed = 0
								";
						$res = $this->db->table($sql);
						if (!empty($res) && count($res) > 0 && $res[0][0] > 0) {
							$this->status = textSys('admin:round:UZUPELNIJ_WSZYSTKIE_MECZE');
							return $round['roundid'];
						}
					}
					
					$this->db->query('START TRANSACTION;');
					/*
					 * Tylko jedna aktywna kolejka
					 */
					if ($round['roundactive'] == 'true') {
						$sql = "UPDATE styper_round SET roundactive = 0 WHERE roundactive = 1";
						$this->db->query($sql);
					}					
		
					if ($round['closed']) {						
						$this->_updateScores();
					}	
					else {					
						$sql = "UPDATE styper_round SET roundname = '{$round['roundname']}', rounddescription = '{$round['rounddescription']}', roundborn = '{$round['roundborn']}', roundactive = {$round['roundactive']} WHERE roundid = '{$round['roundid']}'";
						$this->db->query($sql);
					}
					$this->db->query('COMMIT;');
					$this->status = textSys('admin:round:ZMIANY_ZOSTALY_ZAPISANE');

					$this->goToList();
				}
			}		
			
			return $round['roundid'];
		}		
		
		function getFormular() {			
		
			$this->t->assign('STATUS', $this->status);

			$this->t->assign('rounds', $this->q->getRoundsAllExistingListPaged());	
			$this->t->assign('tablelinks', Table::getLinks($this->getPageUri(), $this->q->limit));
						
			return $this->t->fetch('admin_round.ihtml');
		}
		
		
		function deleteUser() {
			$roundId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'round' , false);
			$me = Typer_Auth::getLoggedUserData(); 
			
			if ($me && $roundId) {				
				$sql = "UPDATE styper_round SET rounddeleted = 1 WHERE roundid = '{$roundId}'";				
				$this->db->query ($sql);				
			
				$this->status = textSys('admin:round:KOLEJKA_USUNIETA');
				$this->goToList();
			}
			else {
				$this->status = textSys('admin:round:KOLEJKA_NIE_USUNIETA');
			}	
			return $this->getFormular();		
		}
		
		
		/*
		 * Zamkniecie kolejki ogranicza sie do uzupelnienia aktualnej punktacji na ostatnia kolejke
		 * dla wszystkich aktywnych uzytkownikow
		 */
		function _updateScores() {
			$roundId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'round' , false);
			
			$points = $this->q->getPoints();			
			if ( !$points) {
				return false;
			}
			
			$sql = "START TRANSACTION;";
			$this->db->query($sql);
			$sql = "UPDATE styper_round SET roundclosed = 1, roundactive = 0 WHERE roundid = '{$roundId}'";
			$this->db->query($sql);			
						
			$users = $this->q->getUsersPureList();
			if (! count($users) > 0) {
				return;
			}
			
			foreach ($users as $key => $val) {
				
				$score = 0;
				$sql = "SELECT * FROM styper_type t LEFT JOIN styper_match m ON t.matchid = m.matchid LEFT JOIN styper_round r ON r.roundid = m.roundid WHERE t.userid = '{$val['userid']}' AND r.roundclosed = 1 AND r.rounddeleted = 0";
				$types = $this->db->table($sql);
		
				/*
				 * rozliczenie za zgodnosc typu z wynikiem
				 */
				foreach ($types as $tkey => $tval) {
					$status = '0';
					if ( empty($tval['matchhost']) && empty($tval['matchguest']) ) {
						continue;
					}
					if ($tval['matchhostscore'] == $tval['typehost'] && $tval['matchguestscore'] == $tval['typeguest']) {
						//echo "bullseye!";
						$score += $points['shot'];
						$status = '3';
					}
					else if($tval['matchhostscore'] - $tval['typehost'] == $tval['matchguestscore'] - $tval['typeguest']) {
						//echo "bramka";
						$score += $points['diff'];
						$status = '2';
					}
					else if(($tval['matchhostscore'] > $tval['matchguestscore']) && ($tval['typehost'] > $tval['typeguest']) || ($tval['matchhostscore'] < $tval['matchguestscore']) && ($tval['typehost'] < $tval['typeguest']) || ($tval['matchhostscore'] == $tval['matchguestscore']) && ($tval['typehost'] == $tval['typeguest'])) {
						//echo "strona";
						$score += $points['side'];
						$status = '1';
					}
					
					if ($tval['matchspecial']) {
						$score += $points['round'];
					}
					$usql = "UPDATE styper_type SET typestatus = '{$status}' WHERE typeid = '{$tval['typeid']}'";
					$this->db->query($usql);
				}				

				$usql = "UPDATE styper_user SET score = '{$score}' WHERE userid = '{$val['userid']}';";
				$this->db->query($usql);
									
			}
			$sql = "COMMIT;";
			$this->db->query($sql);			

		}
				
			
	}
	