<?php

	class Admin_Team extends AdminPage {
		
		function Admin_Team() {			
			parent::AdminPage();			

			$this->status = '';
			$this->content = '';						

			$this->q = new Queries;
			
			$this->db = new DB;	
			$this->t=new Typer_Smarty(ROOT."layout/admin_team/");			
		}
		
		function getContent() {			
			$mode = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'mode' , 1);
			$step = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'step' , 1);
			
			switch ($mode) {
				case 1:
				default:					
					break;
				case 2:
					switch ($step) {
						case 1:
						default:
							return $this->getEditFormular();
						case 2:							
							return $this->getEditFormular($this->updateData());
					}
				case 3:
					return $this->deleteTeam();
			}
			
			return $this->getFormular();
		}

		function goToList() {
			header('location: index.php?fun=30');
			exit();
		}
		
		
		function getEditFormular($teamId = false) {
			if (! $teamId) {
				$teamId = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'team' , false);
			}			
	
			if ( $teamId) {
				$sql = "SELECT * FROM styper_team WHERE teamid = '{$teamId}'";		
				$team = $this->db->table($sql);
			}
			else {
				$team = null;	
			}
			
			if (count ($team) > 0 || $teamId == -1) {
				$this->t->assign('teamid', $teamId == -1 ? -1 : $team[0]['teamid']);				
				$this->t->assign('team', $team[0]);
				$this->t->assign('STATUS', $this->status);
				return $this->t->fetch('admin_team_edit.ihtml');	
			}
			else {
				$this->status = textSys('admin:team:NIE_MA_TAKIEJ_DRUZYNY');
				return $this->getFormular();
			}			
			
		}
				
		function updateData() {
			$team['teamid'] = Verifier::verifyFromREQUEST( INTEGER_NUMBER , 'team' , false);
			$team['teamname'] = Verifier::verifyFromREQUEST( NOT_NULL_STRING , 'team_name' , false);
			
			$eject = false;
			foreach ($team as $u) {
				if (empty($u)) {
					$eject = true;
				}
			}			
			
			if ($team['teamid'] == -1 && !$eject) {

				$sql = "SELECT * FROM styper_team WHERE teamname = '{$team['teamname']}' AND teamactive = 1";
				$res = $this->db->table($sql);
				
				if (count ($res) > 0) {
					$this->status = textSys('admin:team:TAKA_DRUZYNA_JUZ_ISTNIEJE');
					return -1;
				}
				
				$sql = "INSERT INTO styper_team (teamname) VALUES ('{$team['teamname']}')";
				$this->db->query($sql);
				$this->status = textSys('admin:team:DRUZYNA_ZOSTALA_DODANA');
				
				$sql = "SELECT MAX(teamid) FROM styper_team";
				$res = $this->db->table($sql);
				$team['teamid'] = $res[0][0];
				
				$this->goToList();
			}
			else {		
				if (! $eject) {
					$sql = "UPDATE styper_team SET teamname = '{$team['teamname']}' WHERE teamid = '{$team['teamid']}'";
					$this->db->query($sql);
					$this->status = textSys('admin:team:ZMIANY_ZOSTALY_ZAPISANE');	

					$this->goToList();
				}
			}		
			
			return $team['teamid'];			
		}
		
		function deleteTeam() {
			$teamId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'team' , false);
			$me = Typer_Auth::getLoggedUserData(); 
			
			if ($me && $teamId) {				
				$sql = "UPDATE styper_team SET teamactive = 0 WHERE teamid = '{$teamId}'";				
				$this->db->query ($sql);				
		
				$this->status = textSys('admin:team:DRUZYNA_USUNIETA');
				
				$this->goToList();
			}
			else {
				$this->status = textSys('admin:team:DRUZYNA_NIE_ZOSTALA_USUNIETA');
			}	
			
			return $this->getFormular();
		}
		
		function getFormular() {
			$this->t->assign('teams', $this->q->getTeamsListPaged());
			
			$this->t->assign('tablelinks', Table::getLinks($this->getPageUri(), $this->q->limit));			
			$this->t->assign('STATUS', $this->status);
		
						
			return $this->t->fetch('admin_team.ihtml');
		}
		
		function _getTeamsList() {

			$sql = "SELECT * FROM styper_team WHERE teamactive = 1 ORDER BY teamname";
			$res = $this->db->table($sql);		

			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}
		
			return $res;
		}		
	}
	