<?php

	class Admin_User extends AdminPage {
		
		function Admin_User() {			
			parent::AdminPage();			

			$this->status = '';
			$this->content = '';						
			
			$this->q = new Queries;
			
			$this->db = new DB;	
			$this->t=new Typer_Smarty(ROOT."layout/admin_user/");			
		}
		
		function getContent() {			
			$mode = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'mode' , 1);
			$step = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'step' , 1);
			
			switch ($mode) {
				case 1:
				default:					
					break;
				case 2:
					switch ($step) {
						case 1:
						default:
							return $this->getEditFormular();
						case 2:							
							return $this->getEditFormular($this->updateData());
					}
				case 3:
					return $this->deleteUser();
			}
			
			return $this->getFormular();
		}
		
		function getEditFormular($userId = false) {
			if (! $userId) {
				$userId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'user' , false);
			}
			if ( $userId) {			
				$sql = "SELECT * FROM styper_user WHERE userid = '{$userId}'";		
				$user = $this->db->table($sql);
			}
			else {
				$user = null;	
			}
			
			if (count ($user) > 0) {
				$this->t->assign('user', $user[0]);
				$this->t->assign('STATUS', $this->status);
				$this->t->assign('groups', $this->_getGroupsList());
				return $this->t->fetch('admin_user_edit.ihtml');	
			}
			else {
				$this->status = textSys('admin:user:NIE_MA_TAKIEGO_UZYTKOWNIKA');
				return $this->getFormular();
			}			
			
		}
		
		function goToList() {
			header('location: index.php?fun=20');
			exit();
		}
		
		function updateData() {
			$user['userid'] = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'user' , false);
			$user['useremail'] = Verifier::verifyFromREQUEST( EMAIL_ADDRESS , 'user_email' , false);
			$user['groupid'] = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'user_group' , false);

			$user['groupid'] = $user['groupid'] ? $user['groupid'] : "NULL"; 
		
			$eject = false;
			foreach ($user as $u) {
				if (empty($u)) {
					$eject = true;
				}
			}
						
			if (! $eject) {
				$sql = "UPDATE styper_user SET useremail = '{$user['useremail']}', groupid = '{$user['groupid']}' WHERE userid = '{$user['userid']}'";
				$this->db->query($sql);
				$this->status = textSys('admin:user:ZMIANY_ZOSTALY_ZAPISANE');
				$this->goToList();				
			}
			else {
				$this->status = textSys('admin:user:ZMIANY_NIE_ZOSTALY_ZAPISANE');	
			}
			
			return $user['userid'];
		}
		
		function deleteUser() {
			$userId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'user' , false);
			$me = Typer_Auth::getLoggedUserData(); 
			
			if ($me && $userId && ($userId != $me['userid']) && $me['userlogin'] != 'admin') {				
				$sql = "UPDATE styper_user SET useractive = 0 WHERE userid = '{$userId}'";				
				$this->db->query ($sql);
				
				$this->status = textSys('admin:user:UZYTKOWNIK_USUNIETY');
				$this->goToList();
			}
			else {
				$this->status = textSys('admin:user:UZYTKOWNIK_NIE_ZOSTAL_USUNIETY');
			}	
			return $this->getFormular();		
		}
		
		function getFormular() {
						
			$this->t->assign('users', $this->q->getUsersListPaged());
			$this->t->assign('tablelinks', Table::getLinks($this->getPageUri(), $this->q->limit));
								
			$this->t->assign('STATUS', $this->status);
			$this->t->assign('ADMIN_CONTENT', $this->content);
						
			return $this->t->fetch('admin_user.ihtml');
		}
	
		function _getUsersList() {

			$sql = "SELECT * FROM styper_user su LEFT JOIN styper_group sg ON sg.groupid = su.groupid WHERE useractive = 1 ORDER BY userlogin";
	
			$res = $this->db->table($sql);		
			
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}
			
			return $res;
		}
		
		function _getGroupsList() {

			$sql = "SELECT * FROM styper_group ORDER BY groupname";
			$res = $this->db->table($sql);		

			/*for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}*/
		
			return $res;
		}		
}	
	