<?php

define('LOST_PASSWORD_MAGIC', MD5_VALUE);
define('LOST_PASSWORD_HOURS_LIFETIME', 24);

class LostPassword extends TyperPage {
	
	function LostPassword() {
		
		parent::TyperPage();
		if (Typer_Auth::isUserLogged()) {
			header('location: '.MAINPAGE_URI);
		}
		
		$this->status = '';
		
		$this->db = new DB;	
		$this->t=new Typer_Smarty(ROOT."layout/lostpassword/");			
		
	}
	
	function getContent() {

		$who = Typer_Auth::isUserLogged() === true ? 'user' : 'guest';
	
		switch( $who ) {
			case 'user':			
				return $this->_handleUser();				
			case 'guest':				
			default:
				return $this->_handleGuest();
		}		
	}
	
	function _getFormular() {	
		$this->t->assign('STATUS', $this->status);	
		return $this->t->fetch('lostpassword.ihtml');
	}
	
	function _handleUser() {
		$this->t->assign('logged', 't');
		return $this->_getFormular();
	}
	
	function _handleGuest() {		

		$step = Verifier::verifyFromREQUEST(POSITIVE_CARDINAL_NUMBER, 'step', 1);
		$this->t->assign('reset', 'f');
		switch ($step) {
			default:
			case 1:
					break;
			case 2:
					$this->_requestPassReset();	
					break;
			case 3:
					$this->_prepareReset();
					break;
			case 4:
					$this->_handleReset();
					break;
		}		
		$this->t->assign('logged', 'f');		
		return $this->_getFormular();
	}
	
	function _requestPassReset() {
		$db = new DB;
		$email = Verifier::verifyFromREQUEST(NOT_NULL_STRING, 'user_email', false);
		if ( !$email) {
			$this->status = textSys('main:lostpassword:PODAJ_POPRAWNY_ADRES_EMAIL');
			return;
		}
		$email = $db->quoteString($email);
		$sql = " 
				 SELECT userid, userlogin, useremail
				 FROM styper_user
				 WHERE useremail = {$email}
				 AND userdeleted = 0
				 AND useractive = 1		
				";
		$res = $db->table($sql);		
		if (count($res) > 0) {
			$res = $res[0];			
			$body = "W celu ustawienia nowego hasla uzyj linku: ";
			$body .= $this->_generaterUrl($res['userid'], $res['useremail']);
			Mail::sendmail($res['useremail'], textSys('main:lostpassword:PRZYPOMNIENIE_HASLA'), $body);
			$this->status = textSys('main:lostpassword:MAIL_ZOSTAL_WYSLANY');
		}
		else {
			$this->status = textSys('main:lostpassword:EMAIL_NIE_WIDNIEJE_W_BAZIE');
			return;
		}
	}
	
	function _generaterUrl($userId, $useremail) {
		return 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . "?fun=100&step=3&h=" . $userId . "_". md5($useremail . LOST_PASSWORD_MAGIC) . "&ts=" . time(); 
	}
	
	
	function _prepareReset() {
		$db = new DB;
		$h = Verifier::verifyFromREQUEST(NOT_NULL_STRING, 'h', false);
		$hid = explode("_", $h);	$hash = $hid[1];	$id = $db->quoteString($hid[0]); $nqId = $hid[0];
		$ts = Verifier::verifyFromREQUEST(POSITIVE_CARDINAL_NUMBER, 'ts', false);
		if ($h && $ts)	{
			
			$sql = " SELECT *
					 FROM styper_user
					 WHERE userid = {$id}
				 	 AND userdeleted = 0
				 	 AND useractive = 1	
					";
					
			$res = $db->table($sql);			
			if (count($res) > 0) {
					$res = $res[0];				
					if (time() - LOST_PASSWORD_HOURS_LIFETIME * 3600 <= $ts &&
						md5($res['useremail'] . LOST_PASSWORD_MAGIC) === $hash) {
							$this->t->assign('uri', 'index.php?fun=100&step=4&h=' . $nqId . "_" . md5($nqId . LOST_PASSWORD_MAGIC));
							$this->t->assign('reset', 't');
							return;
						}
				}
		}
				
		$this->t->assign('reset', 'f');
		return;
	}
	
	function _handleReset() {
		$db = new DB;
		$pass1 = Verifier::verifyFromREQUEST(NOT_NULL_STRING, 'password1', false);
		$pass2 = Verifier::verifyFromREQUEST(NOT_NULL_STRING, 'password2', false);
		$h = Verifier::verifyFromREQUEST(NOT_NULL_STRING, 'h', false);
		
		if ($h && $pass1 && $pass2 && $pass1 === $pass2) {
			$h = explode("_", $h);
			$id = $h[0]; $hash = $h[1];
			if (md5($id . LOST_PASSWORD_MAGIC) === $hash) {
				$pass = $db->quoteString(md5($pass1.MD5_VALUE));
				$id = $db->quoteString($id);
				$sql = "
						UPDATE styper_user
						SET userpass = {$pass}
						WHERE userid = {$id}
				 		AND userdeleted = 0
				 		AND useractive = 1	
						";

				$db->query($sql);
				$this->status = textSys('main:lostpassword:HASLO_ZOSTALO_ZMIENIONE');		
				return;						
			}
		}
		else {
			$this->status = textSys('main:lostpassword:BLAD_W_USTAWIENIU_HASLA');
		}
	}
	
}

?>