<?php


	class Profile extends TyperPage {
	
	
		function profile() {
			
			parent::TyperPage();
			Typer_Auth::redirectGuest();
			
			$this->status = '';
			
			$this->mailer = new Mail;
			$this->db = new DB;	
			$this->t=new Typer_Smarty(ROOT."layout/profile/");					
		}
		
		function getContent() {
			
			$step = Verifier::verifyFromRequest(POSITIVE_CARDINAL_NUMBER, 'step', 1);
			switch ($step) {
				case 3:
					return $this->inviteNewUser();					
				
				case 2:
					return $this->updateData();
				case 1:
				default:
					return $this->getFormular();
			}
		}
		
		function getFormular() {
			
			$this->t->assign('STATUS', $this->status);
			$this->t->assign('user', $this->getData());
			$this->t->assign('groups', $this->_getGroupsList());
			return $this->t->fetch("profile.ihtml");			
		}
		
		
		function inviteNewUser() {

			$email = Verifier::verifyFromRequest(EMAIL_ADDRESS, 'invite_email', false); 
			
			if (! $email) {
				$this->status = textSys('profile:PODAJ_POPRAWNY_EMAIL');
			}
			else {
				$sql = "
						SELECT useremail
						FROM styper_user
						WHERE useremail = '{$email}'
						AND userdeleted = 0	
					   ";
				
				$res = $this->db->table($sql);
				
				if (! empty($res) && count($res) > 0) {
					$this->status = textSys('profile:TAKI_ADRES_JEST_UZYWANY_W_SYSTEMIE');
				}
				else {
					
					/*
					 * zaproszenie uzytkownika
					 * 
					 */
					$userData = Typer_Auth::getLoggedUserData();
					
					$message = textSys('main:ZAREJESTRUJ_SIE_W_TYPERZE');
					$message .= ' http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . '?fun=5&ref=' . $userData['userid'];
					$message .= "\n\n--\n" . $userData['userlogin']; 
					if ($this->mailer->sendmail($email, textSys('main:ZAPROSZENIE_UZYTKOWNIKA_DO_TYPERA'), $message, false)) {					
						$this->status = textSys('profile:UZYTKOWNIK_ZOSTAL_ZAPROSZONY');
					}
					else {
						$this->status = textSys('profile:WYSLANIE_ZAPROSZENIA_NIE_POWIODLO_SIE');
					}
				}
			}
			return $this->getFormular();
		}
		
		function getData() {
			$usrData = Typer_Auth::getLoggedUserData();
			return $usrData;
		}
		
		function _getGroupsList() {

			$sql = "SELECT * FROM styper_group ORDER BY groupname";
			$res = $this->db->table($sql);		

			/*for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}*/
		
			return $res;
		}		
		
		function updateData() {
			$usrData['useremail'] = Verifier::verifyFromRequest(EMAIL_ADDRESS, 'user_email', false);
			$usrData['userpass'] = Verifier::verifyFromRequest(NOT_NULL_STRING, 'user_password', false);
			$usrData['groupid'] = Verifier::verifyFromRequest(NOT_NULL_STRING, 'user_group', false);
			
			$passwordRepeat = Verifier::verifyFromRequest(NOT_NULL_STRING, 'user_password_repeat', false);
			$lUserData = $this->getData();
			
			if (($usrData['userpass'] xor $passwordRepeat) || ($passwordRepeat != $usrData['userpass'])) {
				$this->status = textSys('profile:NIEWLASCIWE_DANE');
				return $this->getFormular();
			}
			
			$usrData['useremail'] = strip_tags($usrData['useremail']);

			/*
			 * Sprawdzenie adresu email
			 */
			
			$sql = "
					SELECT userid, useremail
				    FROM styper_user
					WHERE useremail = '{$usrData['useremail']}'
					AND userdeleted = 0
				   ";			
			$res = $this->db->table($sql);
			
			
			if (! empty($res) && count ($res) > 0) {
				if ($res[0]['userid'] != $lUserData['userid']) {
					$this->status = textSys('profile:TAKI_ADRES_EMAIL_JEST_UZYWANY_PRZEZ_KOGOS_INNEGO');
					return $this->getFormular();
				}
			}
			
			$remove = Verifier::verifyFromRequest(CHECKBOX, 'user_delete', false);			
			
			/*
			 * Kasacja uzytkownika
			 */
			if ($remove) {								
				Typer_Auth::logout();
				
				if ($usrData['userlogin'] == 'admin') {
					$this->status = textSys('profile:NIE_MOZNA_KASOWAC_ADMINA');
					return false;					
				}
				
				$sql = "UPDATE styper_user SET useractive = 0, userdeleted = 1 WHERE userid = '{$lUserData['userid']}'";				
				$this->db->query($sql);
				Typer_Auth::redirectGuest();
			}
			
			if ($usrData['userpass']) {
				$usrData['userpass'] = md5($usrData['userpass'].MD5_VALUE);
			}
			
			/*
			 * Uaktualnienie profilu
			 */
			$sql = "UPDATE styper_user SET ";
			$parts = array();
			foreach ($usrData as $key => $val) {
				if (empty($val)) {
					$usrData[$key] = 'NULL';
					$val = 'NULL';
					// jedyna wartosc NULL dopuszczalna
					if ($key != 'groupid') {					
						continue;
					}
				}
				$parts [] = "{$key} = '{$val}'";
			}
			$sql .= implode (',', $parts) . " WHERE userid='{$lUserData['userid']}'";				
			$this->db->query($sql);
					
			Typer_Auth::refreshUser();
			
			$this->status = textSys('profile:PROFIL_ZAKTUALIZOWANY');			
			
			return $this->getFormular();
		}				
	}