<?php


	class Rating extends TyperPage {
		
		function Rating() {
			
			parent::TyperPage();				
			//Typer_Auth::redirectGuest();
				
			$this->status = '';
			$this->content = '';
			
			$this->q = new Queries;						
				
			$this->db = new DB;	
			$this->t=new Typer_Smarty(ROOT."layout/rating/");				
		}
		
		function getContent() {
			
			return $this->getFormular();
		}
		
		
		function getFormular() {				
			$roundId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'round' , false);
			
			$this->t->assign('roundId', $roundId);	
			$this->t->assign('rounds', $this->_getRoundsList());
			$this->t->assign('typers', $this->getPagedResults($this->sortByScoreDesc($this->_getTypers())));
			$uri = preg_replace('/&round=\w*/', '', $this->getPageUri());
			$uri .= '&round=' . $roundId;
			$tablelinks = Table::getLinks($uri , $this->limit);

			$this->t->assign('tablelinks', $tablelinks);
			
			return $this->t->fetch('rating_user.ihtml');	
		}
		
		function _getRoundsList() {
			
			$sql = "SELECT * FROM styper_round WHERE roundclosed = 1 AND roundactive = 0 AND rounddeleted = 0 ORDER BY roundid DESC";
			
			$rounds = $this->db->table($sql);
			return $rounds;
		}		
			
		function _getTypers() {
			$roundId = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'round' , false);
			$all = false;			
			if (!$roundId) {
				$all = true;
			}			
					
			$points = $this->q->getPoints();
			if ( !$points) {
				return false;
			}			
					
			$sql = "SELECT * FROM styper_user u LEFT JOIN styper_group g ON g.groupid = u.groupid WHERE u.useractive = 1";

			$users = $this->db->table($sql);
			if (! count($users) > 0) {
				return;
			}
			
			$this->limit = count($users); 
			
			foreach ($users as $key => $val) {
				
				$score = 0;
				$sql = "SELECT * FROM styper_type t LEFT JOIN styper_match m ON t.matchid = m.matchid LEFT JOIN styper_round r ON r.roundid = m.roundid WHERE t.userid = '{$val['userid']}' AND r.roundclosed = 1 AND r.rounddeleted = 0 AND m.roundid " . ($all ? '<' : '') . "= " . ($all ? '(SELECT max(roundid) FROM styper_round)' : "'{$roundId}'") . "";
				$types = $this->db->table($sql);
				
				/*
				 * rozliczenie za zgodnosc typu z wynikiem
				 */
				foreach ($types as $tkey => $tval) {

					if ( empty($tval['matchhost']) && empty($tval['matchguest']) ) {
						continue;
					}
					if ($tval['matchhostscore'] == $tval['typehost'] && $tval['matchguestscore'] == $tval['typeguest']) {
						$score += $points['shot'];
					}
					else if($tval['matchhostscore'] - $tval['typehost'] == $tval['matchguestscore'] - $tval['typeguest']) {
						$score += $points['diff'];
					}
					else if(($tval['matchhostscore'] > $tval['matchguestscore']) && ($tval['typehost'] > $tval['typeguest']) || ($tval['matchhostscore'] < $tval['matchguestscore']) && ($tval['typehost'] < $tval['typeguest']) || ($tval['matchhostscore'] == $tval['matchguestscore']) && ($tval['typehost'] == $tval['typeguest'])) {
						$score += $points['side'];
					}
					
					if ($tval['matchspecial']) {
						$score += $points['round'];
					}
				}				

				$users[$key]['score'] = $score;									
			}
	
			return $users;

		}
		
		function getPagedResults($table) {
			
			$offsets = Table::getOffsets();
			$from = $offsets['size'] * ($offsets['number']-1);			
			$size = $offsets['size'];
			
			$retvals = array();
			for ($i = $from; $i <= $from + $size; $i++ ) {
				if ( !isset($table[$i])) {
					break;
				}
				$retvals [] = $table[$i];
			}
			
			return $retvals;
		}
		
		function sortByScoreDesc($table) {
			if ($table == null) {
				return null;
			}
			
			for ($i = 0; $i < count($table); $i++) {
				for ($j = 0; $j < count($table); $j++) {
					if ($i != $j) {
						if ($table[$j]['score'] < $table[$i]['score']) {
							$tmp = $table[$j];
							$table[$j] = $table[$i];
							$table[$i] = $tmp;
						}
					}
				}
			}
			
			$position = 1;
			for ($i = 0; $i < count($table); $i++) {
				if ($i != 0 && $table[$i]['score'] == $prevScore) {
					$table[$i]['position'] = '';
				}
				else {					
					$table[$i]['position'] = $position;
					$position++;										
				}
				$prevScore = $table[$i]['score'];	
			}
			
			return $table;
		}		
	}