<?php

class Register {
	
	function register() {
		$this->db = new DB;	
		$this->t=new Typer_Smarty(ROOT."layout/register/");
		$this->hideFields = false;
		$this->status = '';
		$this->mailer = new Mail;
	}
	
	function getContent() {
		
		$step = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'step' , 1);
		$ref = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'ref' , false);
		$this->t->assign('referer', $ref);
		
		$this->t->assign('confirmreg', 'f');
		switch ($step) {
			case 3:
				return	$this->_activateUser();
			case 2:
				return	$this->_createUser();				
			case 1:
			default:				
				return $this->getFormular();			
		}		
	}
	
	function getFormular() {
		$this->t->assign ('STATUS', $this->status);
		$this->t->assign ('HIDE', $this->hideFields);
		return $this->t->fetch("register.ihtml");		
	}
	
	function _activateUser() {		
		$h = Verifier::verifyFromREQUEST(NOT_NULL_STRING, 'h', false);		
		$h = explode("_", $h);
		$id = $h[0]; $hash = $h[1];
		
		$referer = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'ref' , false);
		
		if (md5($id . MD5_VALUE) === $hash) {
			$sql = "UPDATE styper_user SET useractive = 1 WHERE userid = '{$id}'";
			$this->db->query($sql);
			
			if (!empty($referer)) {
				/*
				 * referer
				 */
				$sql = "
						INSERT INTO styper_referer
						(userid, newid)
						VALUES('$referer', '$id')
					   ";
				$this->db->query($sql);
			}								
			
			$this->t->assign('confirmreg', 't');
			$this->notRenderRoot = true;	
					
		}
		else {
			$this->status = textSys('main:register:NARUSZENIE_BEZPIECZENSTWA');
		}
		return $this->getFormular();
	}
	
	function _createUser() {		
		
		$newUser = array();
		
		$newUser['userlogin'] = Verifier::verifyFromREQUEST( NOT_NULL_STRING , 'user_login' , false);		
		$newUser['useremail'] = Verifier::verifyFromREQUEST( EMAIL_ADDRESS , 'user_email' , false);
		$newUser['userpassword'] = Verifier::verifyFromREQUEST( NOT_NULL_STRING , 'user_password' , false);
		$passwordRepeat = Verifier::verifyFromREQUEST( NOT_NULL_STRING , 'user_password_repeat' , false);
		
		
		$referer = Verifier::verifyFromREQUEST( POSITIVE_CARDINAL_NUMBER , 'ref' , false);
		$eject = false;
		
		
		// skasowanie wszystkich spacji z wpisanego loginu
		$newUser['userlogin'] = preg_replace("/ /", '', $newUser['userlogin']);
		
		$newUser['userlogin'] = strip_tags($newUser['userlogin']);
		$newUser['useremail'] = strip_tags($newUser['useremail']);		
		
		// sprawdzenie pobranych danych
		foreach ($newUser as $nU) {
			if ( empty($nU)) {				
				$eject = true;
			}
		}
		
		// czy wpisane hasla w polu haslo i powtorzone sa takie same
		if ($newUser['userpassword'] !== $passwordRepeat) {
			$eject = true;
		}
		
		if (! $eject) {
			
			$sql = "
					SELECT * FROM styper_user
				    WHERE 
					( 
						useremail = '{$newUser['useremail']}'					 
						AND userdeleted = 0
					)
					OR
					userlogin = '{$newUser['userlogin']}'
					";
			$results = $this->db->first($sql);
			
			if (!empty($results) && count($results) > 0) {
				$this->status = textSys('main:register:LOGIN_EMAIL_SA_JUZ_W_SYSTEMIE');
				return $this->getFormular();
			}

			$this->db->query('START TRANSACTION;');
			
			$active = !EXTENDED_REGISTRATION;
			$active = $active ? '1' : '0';			
			$newUser['userpassword'] = md5($newUser['userpassword'].MD5_VALUE);			
			$sql = "INSERT INTO styper_user (userlogin, userpass, useremail, userborn, useractive) VALUES (
				'{$newUser['userlogin']}', '{$newUser['userpassword']}', '{$newUser['useremail']}', (NOW()), {$active})";

			$this->db->query($sql);
			
			$sql = "
					SELECT userid
					FROM styper_user
					WHERE
						 useremail = '{$newUser['useremail']}'
						AND userlogin = '{$newUser['userlogin']}'
					";
			$userId = $this->db->table($sql);
			$userId = $userId[0][0];
			
			$this->status = textSys('main:register:UZYTKOWNIK_ZOSTAL_ZAREJESTROWANY');
			if ( EXTENDED_REGISTRATION) {
				$this->status .= "\n" . textSys('main:register:OCZEKUJ_MAILA_Z_AKTYWACJA');	
			}
			$this->hideFields = true;
			
			// dla jednej fazy
			$mailSent = true;
			if ( EXTENDED_REGISTRATION) {
				$body = textSys('main:register:W_CELU_AKTYWACJI_KONTA_LINK');
				$body .= ' ' . 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'] . '?fun=5&step=3&ref=' . $referer . '&h=' . $userId . '_' . md5($userId . MD5_VALUE);
				$mailSent = $this->mailer->sendmail($newUser['useremail'], textSys('main:register:AKTYWACJA_KONTA'), $body, false);				
			}
			else {
				/*
				 * referer
				 */
				$sql = "
						INSERT INTO styper_referer
						(userid, newid)
						VALUES('$referer', '$userId')
					   ";
				$this->db->query($sql);								
			}
			
			if ( !$mailSent) {
				$this->db->query('ROLLBACK;');
				$this->status = textSys('main:register:WYSLANIE_MAILA_NIE_POWIODLO_SIE');
			}
			else {
				$this->db->query('COMMIT;');
			}
			
			return $this->getFormular();
		}
		else {
			$this->status = textSys('main:register:PODAJ_WYMAGANE_INFORMACJE');
			return $this->getFormular();
		}
	}
	
}

?>