<?php


	class Stats_Global extends TyperPage {
		
			function Stats_Global() {
				
				parent::TyperPage();
				//Typer_Auth::redirectGuest();
				
				$this->status = '';
				$this->content = '';						
				
				$this->db = new DB;	
				$this->t=new Typer_Smarty(ROOT."layout/stats_global/");					
			}
			
			function getContent() {				
	
				return $this->getFormular();
			}
			
			function getFormular() {
				
				$this->t->assign('round', $this->_getPlayedRound());
				$this->t->assign('userscount', $this->_getTypersCount());
				$this->t->assign('roundscount', $this->_getRoundsCount());
				$this->t->assign('accuracy', $this->_getAccuracy());
				$this->t->assign('mosthit', $this->_getMostHitTeam());
				$this->t->assign('leasthit', $this->_getLeastHitTeam());
				
				return $this->t->fetch('stats_global.ihtml');
			}
			
			function _getPlayedRound() {
				
				$sql = "SELECT * FROM styper_round WHERE rounddeleted = 0 AND roundactive = 1";
				$round = $this->db->table($sql);
				if (count ($round) > 0) {
					return $round[0];
				}
				return false;
			}
			
			function _getTypersCount() {
				$sql = "SELECT count(*) FROM styper_user WHERE useractive = 1";
				$count = $this->db->table($sql);
				if (count ($count) > 0) {
					return $count[0][0];
				}	
				return false;		
			}
			
			function _getRoundsCount() {
				$sql = "SELECT count(*) FROM styper_round WHERE rounddeleted = 0";
				$count = $this->db->table($sql);
				if (count ($count) > 0)	{
					
					$this->_roundsCount = $count[0][0];
					return $count[0][0];					
				}	
				return false;				
			}
			
			function _getAccuracy() {
								
				$sql = "SELECT count(*) FROM styper_type";
				$all = $this->db->table($sql);
				$sql = "SELECT count(*) FROM styper_type WHERE typestatus > 0";
				$hit = $this->db->table($sql);
				
				if ($all[0][0] > 0 && $hit[0][0] > 0) {					
				
					$all = $all[0][0];				
					$hit = $hit[0][0];
					
					$accuracy = ceil(($hit / $all) * 100) . '%';
					return $accuracy; 
				}
				return textSys('stats:BRAK_DANYCH');
				
			}
		
			
			function _getMostHitTeam() {
			
				$sql = "
						SELECT
							 te.teamid, te.teamname, SUM(ty.typestatus) as score
						FROM
							 styper_team te, styper_type ty
							 LEFT JOIN styper_match ma ON ty.matchid = ma.matchid
					    WHERE
							 ma.matchhost = te.teamid
							 OR ma.matchguest = te.teamid
							 AND ty.typestatus > 0
					    GROUP BY 
						     te.teamid
						ORDER BY
						     score DESC
						LIMIT 0, 4
					  ";
				$res = $this->db->table($sql);
				$teams = array();
				if (count ($res) > 0) {
					foreach ($res as $val) {
						$teams[] = $val['teamname'];
					}			
					$teams = implode (',', $teams);		
				}
				return $teams;
			}
			
			function _getLeastHitTeam() {

				$sql = "
						SELECT
							 te.teamid, te.teamname, SUM(ty.typestatus) as score
						FROM
							 styper_team te, styper_type ty
							 LEFT JOIN styper_match ma ON ty.matchid = ma.matchid
					    WHERE
							 ma.matchhost = te.teamid
							 OR ma.matchguest = te.teamid
							 AND ty.typestatus > 0
					    GROUP BY 
						     te.teamid
						ORDER BY
						     score ASC
						LIMIT 0, 4
					  ";		
				$res = $this->db->table($sql);
				$teams = array();
				if (count ($res) > 0) {
					foreach ($res as $val) {
						$teams[] = $val['teamname'];
					}			
					$teams = implode (',', $teams);		
				}
				return $teams;				
			}
	}