<?php

	/*
	 * 
	 * Klasa trzymajaca zapytania do bazy
	 * 
	 * 
	 */

	class Queries {
		
		function Queries() {
			
			$this->db = new DB;
		}	
	
		/*
		 *  Zebranie listy zamknietych - nieaktywnych kolejek
		 */		
		function getRoundsList() {
			
			$sql = "SELECT * FROM styper_round WHERE roundclosed = 1 AND roundactive = 0 AND rounddeleted = 0 ORDER BY roundid DESC";
			
			$rounds = $this->db->table($sql);
			return $rounds;
		}
		
		/*
		 *  Pobranie aktualnej punktacji
		 */
		function getPoints() {
			$check = "SELECT COUNT(*) FROM styper_setting";
			$res = $this->db->table($check);
			if (count($res) > 0 && $res[0][0] != 4) {
				$this->status = 'Blad w integralnosci bazy danych';
				return false;
			}
			
			$sql = "SELECT * FROM styper_setting ORDER BY settingid ASC";
			$res = $this->db->table($sql);
				
			$data = array();		
			$data['shot'] = $res[0]['settingvalue'];
			$data['diff'] = $res[1]['settingvalue'];
			$data['side'] = $res[2]['settingvalue'];
			$data['round'] = $res[3]['settingvalue'];			
			
			return $data;	
		}
		
		/*
		 * Sciagniecie listy grup
		 */				
		function getGroupsList() {

			$sql = "SELECT * FROM styper_group ORDER BY groupname";	
			$res = $this->db->table($sql);		
		
			return $res;
		}
		
		/*
		 * Lista grup stronicowana
		 * 
		 */		
		 function getGroupsListPaged() {

			$offsets = Table::getOffsets();
			$from = $offsets['size'] * ($offsets['number']-1);			
			$size = $offsets['size'];

			$sql = "SELECT * FROM styper_group ORDER BY groupid ASC LIMIT {$from}, {$size}";	
			$res = $this->db->table($sql);		

			$delta = $from;
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1 + $delta;
			}
			
			$sql = "SELECT COUNT(*) FROM styper_group";
			$limit = $this->db->table($sql);
			
			$this->limit = $limit[0][0];
		
			return $res;
		}
		
		function getUsersList() {

			$sql = "SELECT * FROM styper_user su LEFT JOIN styper_group sg ON sg.groupid = su.groupid WHERE useractive = 1 ORDER BY userlogin";	
			$res = $this->db->table($sql);		
			
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}
			
			return $res;
		}
		
		function getUsersPureList() {

			$sql = "SELECT * FROM styper_user WHERE useractive = 1 ORDER BY userlogin";	
			$res = $this->db->table($sql);		
			
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}
			
			return $res;			
		}
		
		function getUsersListPaged() {

			$offsets = Table::getOffsets();
			$from = $offsets['size'] * ($offsets['number']-1);			
			$size = $offsets['size'];

			$sql = "SELECT * FROM styper_user su LEFT JOIN styper_group sg ON sg.groupid = su.groupid WHERE useractive = 1 ORDER BY userid ASC  LIMIT {$from}, {$size}";
	
			$res = $this->db->table($sql);		
	
			$delta = $from;			
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1 + $delta;
			}
			
			$sql = "SELECT COUNT(*) FROM styper_user WHERE useractive = 1";
			$limit = $this->db->table($sql);
			
			$this->limit = $limit[0][0];			
						
			return $res;
		}
		
		function getNews() {
			
			$sql = "SELECT * FROM styper_news";
			$res = $this->db->table ($sql);
			
			return $res;
		}
		
		function getNewsPaged() {

			$offsets = Table::getOffsets();
			$from = $offsets['size'] * ($offsets['number']-1);			
			$size = $offsets['size'];

			
			$sql = "SELECT * FROM styper_news ORDER BY newsid ASC LIMIT {$from}, {$size}";
			$res = $this->db->table ($sql);

			$sql = "SELECT COUNT(*) FROM styper_news";
			$limit = $this->db->table($sql);

			$delta = $from;			
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1 + $delta;
			}			
			
			$this->limit = $limit[0][0];		

			
			return $res;
		}
		
		function getTeamsList() {

			$sql = "SELECT * FROM styper_team WHERE teamactive = 1 ORDER BY teamname";
			$res = $this->db->table($sql);		

			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1;
			}
		
			return $res;
		}		

		function getTeamsListPaged() {

			$offsets = Table::getOffsets();
			$from = $offsets['size'] * ($offsets['number']-1);			
			$size = $offsets['size'];

			$sql = "SELECT * FROM styper_team WHERE teamactive = 1 ORDER BY teamname LIMIT {$from}, {$size}";
			$res = $this->db->table($sql);		

			$delta = $from;
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1 + $delta;
			}

			$sql = "SELECT COUNT(*) FROM styper_team WHERE teamactive = 1";
			$limit = $this->db->table($sql);
			
			$this->limit = $limit[0][0];		

		
			return $res;
		}
		
		function getRoundsAllExistingList() {
			
			$offsets = Table::getOffsets();
			$from = $offsets['size'] * ($offsets['number']-1);			
			$size = $offsets['size'];

			$sql = "SELECT * FROM styper_round WHERE rounddeleted = 0 ORDER BY roundborn DESC LIMIT {$from}, {$size}";
			$res = $this->db->table($sql);		

			$delta = $from;
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1 + $delta;
			}
		
			return $res;
		}		
		
		function getRoundsAllExistingListPaged() {

			$offsets = Table::getOffsets();
			$from = $offsets['size'] * ($offsets['number']-1);			
			$size = $offsets['size'];

			$sql = "SELECT * FROM styper_round WHERE rounddeleted = 0 ORDER BY roundborn DESC LIMIT {$from}, {$size}";
			$res = $this->db->table($sql);		

			$delta = $from;
			for ($i = 0; $i < count($res); $i++) {
				$res[$i]['position'] = $i + 1 + $delta;
			}
			
			$sql = "SELECT COUNT(*) FROM styper_round WHERE rounddeleted = 0";
			$limit = $this->db->table($sql);
			
			$this->limit = $limit[0][0];		
			
		
			return $res;
		}				
		
		
	}